<template>
  <div id="kontaktformular" class="module module-contactform">
    <div class="row">
      <div class="col-12 col-md-5 offset-lg-1">
        <h2
          v-if="data.headline"
          class="small"
          v-html="$stripPTags(data.headline)"
        ></h2>
        <div v-if="data.text" class="abstract" v-html="data.text"></div>
      </div>
      <div class="col-12 col-md-6 col-lg-4 offset-md-1">
        <form :class="{ disabled : sent }" @submit.prevent="submitForm">
          <div class="form-group">
            <label for="nameInput" class="hidden">Vorname, Name</label>
            <input
              id="nameInput"
              v-model="mail.name"
              placeholder="Vorname, Name"
              type="text"
              class="form-control text"
              :disabled="sent"
            />
          </div>
          <div class="form-group">
            <label for="emailInput" class="hidden">E-Mail-Adresse</label>
            <input
              id="emailInput"
              v-model="mail.from"
              class="form-control text"
              type="email"
              placeholder="E-Mail-Adresse"
              pattern="[a-z0-9._%+-]+@[a-z0-9.-]+\.[a-z]{2,4}$"
              :disabled="sent"
              required
            />
          </div>
          <div class="form-group">
            <label for="subjectInput" class="hidden">Betreff/Thema</label>
            <select
              id="subjectInput"
              v-model="mail.subject"
              class="form-control select"
              name="subjectInput"
              :disabled="sent"
              required
            >
              <option selected disabled value="">Betreff/Thema</option>
              <optgroup
                v-for="group in subjects"
                :key="group.title"
                :value="group.title"
                :label="group.title"
              >
                <option v-for="project in group.projects" :key="project.id">
                  {{ project.title }}
                </option>
              </optgroup>
            </select>
          </div>
          <div class="form-group">
            <label for="textlInput" class="hidden"
              >Gib hier deine Nachricht ein...</label
            >
            <textarea
              id="textInput"
              v-model="mail.text"
              class="form-control textarea"
              rows="4"
              placeholder="Gib hier deine Nachricht ein..."
              :disabled="sent"
              required
            />
          </div>
          <atom-checkbox class="checkbox">
            <nuxt-link to="/datenschutz">Datenschutz</nuxt-link> akzeptieren
          </atom-checkbox>
          <button v-if="!sent" name="submit" type="submit" class="btn btn-primary" :disabled="sent">
            Absenden
          </button>
          <div v-if="sent || error !== null" class="form-msg">
            <p v-if="error" v-html="error"></p>
            <p v-else>Vielen Dank für Ihre Nachricht.</p>
          </div>
        </form>
      </div>
    </div>
  </div>
</template>

<script>
/* eslint-disable no-unused-vars */
import gql from 'graphql-tag';

export default {
  props: {
    data: {
      type:Object,
      default: () => {},
    }
  },
  data() {
    return {
      projects: {},
      error: null,
      sent: false,
      mail: {
        name: '',
        from: '',
        subject: '',
        text: '',
      },
    };
  },
  async fetch() {
    const client = this.$apolloProvider.defaultClient;

    await client.query({
      query: gql`
        query Subjects {
          projekte {
            edges {
              node {
                id
                title
              }
            }
          }
          impulsprojekte {
            edges {
              node {
                id
                title
              }
            }
          }
        }
      `,
      prefetch: true,
    }).then((result) => {
      this.projects = result.data;
    }).catch((err) => {
      console.log(err);
    });
  },
  computed: {
    subjects() {
      const subjects = [];

      for (const [key, value] of Object.entries(this.projects)) {
        const optGroup = {
          title: key.charAt(0).toUpperCase() + key.slice(1),
          projects: [],
        }

        value.edges.forEach((subject) => {
          const project = {
            title: subject.node.title,
            id: subject.node.id,
          }

          optGroup.projects.push(project);
        })

        subjects.push(optGroup);
      }

      return subjects;
    },
    bodyMessage() {
      let msg = '';

      if (this.mail.name) {
        msg += `Name: ${this.mail.name}<br/><br/>`;
      }

      msg += `Projekt: ${this.mail.subject}<br/><br/>`;
      msg += `Nachricht: ${this.mail.text}`;

      return msg;
    },
  },
  methods: {
    async submitForm () {
      const { from, subject, name } = this.mail;

      await this.$apollo.mutate({
        mutation: gql`
          mutation SEND_EMAIL($from: String!, $subject: String!, $text: String!, $id: String!) {
            sendEmail(
              input: {
                from: $from
                subject: $subject
                body: $text
                clientMutationId: $id
              }
            ) {
              origin
              sent
              message
            }
          }
        `,
        variables: {
          name,
          subject,
          from,
          text: this.bodyMessage,
          id: this._uid,
        },
      }).then((result) => {
        this.error = !result.data.sendEmail.sent ? 'Ihre Nachricht konnte nicht gesendet werden.' : null;
        this.sent = result.data.sendEmail.sent;
      }).catch((error) => {
        console.log('contactform error:', error);
      });
    },
  },
}
</script>

<style lang="scss">
.module-contactform {

  form.disabled {
    .form-group,
    .custom-checkbox {
      opacity: 0.4;
    }
  }

  .form-group {
    margin-bottom: 1.625rem;
    label.hidden {
      display: block;
      visibility: hidden;
      opacity: 0;
      height: 0;
      margin: 0;
      padding: 0;
    }
  }

  .form-control {
    height: auto;
    padding: 0.375rem 0;
    font-size: 1rem;
    font-weight: 400;
    line-height: 1.5em;
    color: $black;
    letter-spacing: 0.2px;
    border: none;
    border-bottom: 2px solid $black;
    border-radius: 0;
    background-color: transparent;

    &::placeholder {
      color: $black;
    }

    &:focus {
      background-color: transparent;
      border-color: inherit;
      color: inherit;
      box-shadow: none;
    }
  }

  .checkbox {
    display: block;
    margin-bottom: 2rem;
  }

  .select {
    position: relative;
    -webkit-appearance: none;
    -moz-appearance: none;
    appearance: none;
    background-image: url('/img/icons/slider-arrow-down.svg');
    background-repeat: no-repeat;
    background-size: 0.75rem;
    background-position: right center;

    option {
      -moz-padding-start: 0px;
      -moz-padding-end: 0px;
    }

    &::-ms-expand {
      display: none;
    }
  }

  .submit {
    margin: 0 auto;
    display: block;

    @include media-breakpoint-up(md) {
      margin: 0;
    }
  }

  .abstract {
    margin-bottom: 1.625rem;

    @include media-breakpoint-up(md) {
      margin-bottom: 0;
    }
  }

  .form-msg {
    border: 2px solid $green;
    padding: 1rem;
    text-align: center;
  }
}

.bg-black {
  .module-contactform {
    .form-control {
      color: $white;
      border-color: $white;

      &::placeholder {
        color: $white;
      }
    }

    .select {
      background-image: url('/img/icons/slider-arrow-down-white.svg');

      option {
        color: $black;
      }

       &::placeholder {
        color: $black;
      }
    }
  }
}
</style>
